var canvas, context;
var gImage;
var WIDTH, HEIGHT;
var frameRate = 5;
var refreshCount = 0;
var battery;
var currentFrame;
var TIMELINE_MAX_VALUE = 24 * 60 * 60 * frameRate;
var dayOfWeek = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
var dayOfWeekFull = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
var monthStr = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
var monthStrFull = ["January", "Febuary", "March", "April", "May", "Jun", "July", "August", "September", "October", "November", "December"];
var maximumDays = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
var imgimg872png = new Image();
var imgimg11989png = new Image();
var imgimg11995png = new Image();
var imgimg11995png = new Image();
var imgimg11995png = new Image();
var imgimg11992png = new Image();
var imgimg11993png = new Image();
var imgimg12000png = new Image();

window.requestAnimationFrame ||
    window.webkitRequestAnimationFrame ||
    window.mozRequestAnimationFrame ||
    window.oRequestAnimationFrame ||
    window.msRequestAnimationFrame ||
    function (/* function */ callback) {
        'use strict';
        window.setTimeout(callback, 1000 / frameRate);
    };

function getDate() {
    'use strict';

    var date;
    try {
        date = tizen.time.getCurrentDateTime();
    } catch (err) {
        console.error('Error: ', err.message);
        date = new Date();
    }

    return date;
}

function findByValue(isTime, array, value) {
    if (isTime) {
        if (value === TIMELINE_MAX_VALUE) {
            value = 0;
        }

        for (var i = 0; i<array.length; i++) {
            if (array[i][0] <= value && array[i][1] > value) {
                return true;
            }
        }
    } else {
        for (var i = 0; i<array.length; i++) {
            if (array[i][0] <= value && array[i][1] >= value) {
                return true;
            }
        }
    }

    return false;
}

function refresh() {
    'use strict';
    //Erase the previous time
    context.clearRect(0, 0, context.canvas.width, context.canvas.height);

    //Import the current time
    var date = getDate();
    var hours = date.getHours();
    var minutes = date.getMinutes();
    var seconds = date.getSeconds();
    var hour = hours + minutes / 60;
    var minute = minutes + seconds / 60;
    var milliseconds = seconds + date.getMilliseconds()/1000.0;
    var frame = parseInt(date.getMilliseconds()/(1000/frameRate));
    var angle;
    var text;
    var extent;
    var nextX;

    hours = hours > 12 ? hours - 12 : hours;
    currentFrame = (date.getHours() * frameRate * 60 * 60) + (minutes * frameRate * 60) + (seconds * frameRate) + frame;
    context.save();

    imgimg872png.src = ".img872.png";
    context.drawImage(imgimg872png, -10, -10, 380, 380);
    context.restore();
    context.save();

    imgimg11989png.src = ".img11989.png";
    context.drawImage(imgimg11989png, 220, 125, 100, 56);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "18px arbrnplt";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#000000";
    text = dayOfWeek[date.getDay()];
    context.fillText(text, 253, 183);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "18px arbrnplt";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#000000";
    text = ((date.getDate()<10) ? "0"+date.getDate() : date.getDate().toString());
    context.fillText(text, 298, 184);
    context.restore();
    context.save();

    angle = null
    context.translate(179, 94);
    context.rotate(angle);
    imgimg11995png.src = ".img11995.png";
    context.drawImage(imgimg11995png, -200, -200, 400, 400);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((seconds - 0.000000) / (60.000000 - 0.000000))) + (frame < 4 ? (frame == 0 ? 0.000000 : (0.000000 * (4 - frame)/4)) : 0))*Math.PI/180;
    context.translate(89, 180);
    context.rotate(angle);
    imgimg11995png.src = ".img11995.png";
    context.drawImage(imgimg11995png, -200, -200, 400, 400);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((date.getMonth() + 1 - 0.000000) / (12.000000 - 0.000000))))*Math.PI/180;
    context.translate(181, 269);
    context.rotate(angle);
    imgimg11995png.src = ".img11995.png";
    context.drawImage(imgimg11995png, -200, -200, 400, 400);
    context.restore();
    context.save();

    angle = (0.000000 + ((720.000000 - 0.000000) * ((hour - 0.000000) / (24.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    imgimg11992png.src = ".img11992.png";
    context.drawImage(imgimg11992png, -185, -185, 370, 370);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((minute - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    imgimg11993png.src = ".img11993.png";
    context.drawImage(imgimg11993png, -175, -175, 350, 350);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((milliseconds - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    imgimg12000png.src = ".img12000.png";
    context.drawImage(imgimg12000png, -190, -190, 380, 380);
    context.restore();
    context.save();

    context.restore();
    window.requestAnimationFrame(refresh);
    refreshCount++;
}

window.onload = function () {
    'use strict';
    canvas = document.getElementById('clock');
    console.log('onload called');
    context = canvas.getContext('2d');

    canvas.width = document.width;
    canvas.height = document.height;

    WIDTH = document.width;
    HEIGHT = document.height;

    gImage = new Image();

    battery = navigator.battery || navigator.webkitBattery || navigator.mozBattery;

    //add eventListener for tizenhwkey
    window.addEventListener('tizenhwkey', function (e) {
        if (e.keyName == 'back') {
            try {
                tizen.application.getCurrentApplication().exit();
            } catch (err) {
                console.log('Error: ', err.message);
            }
        }
    });

    window.requestAnimationFrame(refresh);

};
